$STRICT
C         ********  MAIN  PROGRAM   DRILL   **********
C
C          GIVES SPHERICAL COORDINATES FOR USE ON THE  VPI&SU
C          GEOLOGY DEPARTMENT MODEL BALL DRILLING MACHINE
C
C                RHO = SETTING FOR THE MOVEMENT OF THE  HORIZONTAL ARM
C                PHI = SETTING ON THE CIRCULAR DIAL AT THE END OF
C                         THE BALL ROD
C     revised by Bob Downs 04/08/90
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MAXU=300)
      CHARACTER  NCB(MAXU)*1,ATA(MAXU)*6,TITLE*80
      DIMENSION DMB(MAXU),P(MAXU,3),CELL(6)
      INTEGER NTR(MAXU),NLT(MAXU)

      PI = DACOS(-1.0D0)
      READ(8,100,END=990,ERR=990)TITLE
100   FORMAT(A80)
      WRITE (9,100)TITLE
C     NSG=SPACE GROUP NUMBER
      READ(8,*,END=991,ERR=991)(CELL(I),I=1,6),NSG
      WRITE (9,110)(CELL(I),I=1,6)
110   FORMAT(1X,3F9.4,5X,3F9.3/)

      CALL DRLA(CELL,ATA,NTR,P,DMB,NCB,K,NSG,NLT,NLAT)

      CELL(4)=CELL(4)*PI/180.0D0
      CELL(5)=CELL(5)*PI/180.0D0
      CELL(6)=CELL(6)*PI/180.0D0
      CALL DRLB(CELL,ATA,NTR,P,DMB,NCB,K,NLT,NLAT)
      STOP
990   WRITE(*,*)' AN ERROR WAS DETECTED CONCERNING THE DATA FILE,',
     +          ' NO DATA WAS FOUND'
      STOP
991   WRITE(*,*)' THE PROGRAM HAS DETECTED AN ERROR IN THE DATA FILE:'
      WRITE(*,*)'  THE SECOND LINE SHOULD INCLUDE THE 6 CELL PARAMETERS'
      WRITE(*,*)'   AND THE SPACE GROUP NUMBER'
      STOP
      END
************************************************************************
      SUBROUTINE DRLA(CELL,ATA,NTR,P,DMB,NCB,K,NSG,NLT,NLAT)
C     THIS SUBROUTINE READS ALL THE DATA, AND GENERATES ALL THE ATOMS
C     IN THE UNIT CELL FROM THE INPUT TRANSFORMATION MATRICES
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MAXA=80, MAXU=300)
      CHARACTER NCA(MAXA)*1,NCB(MAXU)*1,ATOM(MAXA)*6,ATA(MAXU)*6
      DIMENSION DMA(MAXA),DMB(MAXU),X(MAXA,4),P(MAXU,3),T(3,4,48),
     +       XLAT(4,3), CELL(6)
      INTEGER NTR(MAXU),NLT(MAXU)

C     NSY=# OF SYMMETRY OPERATIONS
C     NLAT=NUMBER OF LATTICE VECTOR TYPES
      CALL GENERT(NSG,CELL,T,NSY,XLAT,NLAT)
      WRITE (9,*)' SYMMETRY TRANSFORMATIONS'
      WRITE (9,*)' lattice vectors'
      DO 100 I=1,NLAT
         WRITE(9,1)I,(XLAT(I,J),J=1,3)
1        FORMAT(I4,2X,3F6.2)
100   CONTINUE
      WRITE(9,*)' '
      DO 122 K=1,NSY
         WRITE (9,123)K,((T(I,J,K),J=1,4),I=1,3)
123      FORMAT(I4,2X,4F6.2/6X,4F6.2/6X,4F6.2/)
122   CONTINUE

C     READ ATOM COORDINATES
      READ(8,*,END=991,ERR=991)NATO
      IF(NATO.GT.MAXA)THEN
         WRITE(*,*)'    The program is not dimensioned for the number of
     + atoms you have input.'
         WRITE(*,*)'    Change the parameter "MAXA" in the fortran code
     +to be larger than your number of atoms '
         WRITE(*,*)'    in the asymmetric unit, and recompile.'
         STOP
      ENDIF
      DO 132 I=1,NATO
         READ(8,*,END=990,ERR=990)ATOM(I),(X(I,J),J=1,3),DMA(I),NCA(I)
         X(I,4)=1.0D0
132   CONTINUE

C     GENERATE ALL ATOMS IN THE UNIT CELL
      K=0
      DO 208 NA=1,NATO
         KB=K+1
         DO 204 NS=1,NSY
            DO 187 IX=1,NLAT
            KC=K
            K=K+1
            ATA(K)=ATOM(NA)
            NLT(K)=IX
            NTR(K)=NS
            DMB(K)=DMA(NA)
            NCB(K)=NCA(NA)
C           TO 186 THIS LOOP GENERATES EQUIVALENT ATOMS IN THE UNIT CELL
            DO 186 I=1,3
               P(K,I)=XLAT(IX,I)
               DO 178 J=1,4
                  P(K,I)=P(K,I)+T(I,J,NS)*X(NA,J)
178            CONTINUE
180            IF(P(K,I))182,183,183
182            P(K,I)=P(K,I)+1.0D0
               GO TO 180
183            IF(P(K,I)-.9999D0)186,184,184
184            P(K,I)=P(K,I)-1.0D0
               GO TO 183
186         CONTINUE
            IF(K -1)188,187,188
C     THIS LOOP CHECKS TO SEE IF ATOM COORDINATES ARE DUPLICATED ALREADY
188         DO 203 KA=1,KC
               IF(ATA(K).NE.ATA(KA)) GOTO 203
               KT=0
               DO 201 I=1,3
                  IF(DABS(P(K,I)-P(KA,I))-.0002D0)200,200,201
200               KT=KT+1
201            CONTINUE
               IF(KT-3)203,202,203
202            K=K-1
               GO TO 187
203         CONTINUE
187         CONTINUE
204      CONTINUE
208   CONTINUE

      IF(K.GT.MAXU)THEN
         WRITE(*,*)'    The program is not dimensioned for the number of
     + atoms generated.'
         WRITE(*,*)'    Change the parameter "MAXU" in the fortran code
     +to be larger than your number of atoms '
         WRITE(*,*)'    and recompile.'
         STOP
      ENDIF

      IF(NLAT.EQ.1)THEN
         WRITE (9,238)
238   FORMAT(  '    ATOM   TRANS.    X        Y        Z         DMAX
     +CATION/ANION')
         DO 250 KA=1,K
            WRITE (9,240)KA,ATA(KA),NTR(KA),(P(KA,J),J=1,3),
     +                DMB(KA),NCB(KA)
240         FORMAT(1X,I3,1X,A6,'(',I2,')',3F9.5,5X,F7.3,7X,A1)
250      CONTINUE
      ELSE
         WRITE (9,241)
241   FORMAT(  '    ATOM   TRANS.      X        Y        Z         DMAX
     + CATION/ANION')
         DO 251 KA=1,K
            WRITE (9,242)KA,ATA(KA),NLT(KA),NTR(KA),(P(KA,J),J=1,3),
     +                DMB(KA),NCB(KA)
242         FORMAT(1X,I3,1X,A6,'(',I1,',',I2,')',3F9.5,5X,F7.3,7X,A1)
251      CONTINUE
      ENDIF

      RETURN
990   WRITE(*,*)' AN ERROR HAS BEEN DETECTED IN THE DATA FILE'
      WRITE(*,*)'    CHECK THE PARAMETERS FOR ATOM ', I
      WRITE(*,*)'    THERE SHOULD BE:'
      WRITE(*,*)'    (1) THE NAME OF AN ATOM (IN QUOTES)'
      WRITE(*,*)'    (2) FOLLOWED BY 3 POSITIONAL PARAMETERS'
      WRITE(*,*)'    (3) THE MAXIMUM DISTANCE TO BONDED ATOMS'
      WRITE(*,*)'    (4) A or C (IN QUOTES) DEFINING ANION or CATION'
      STOP
991   WRITE(*,*)' AN ERROR HAS BEEN DETECTED IN THE DATA FILE:'
      WRITE(*,*)'    THE PROGRAM EXPECTED TO READ THE NUMBER OF ATOMS'
      WRITE(*,*)'    OR THERE COULD BE AN ERROR IN A PRECEEDING LINE'
      STOP
      END
************************************************************************
      SUBROUTINE DRLB(CELL,ATA,NTR,P,DMB,NCB,K,NLT,NLAT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (NCOORD=30, MAXU=300)
      DIMENSION A(3,3),R(NCOORD),DA(3),DB(3),DC(3),VI(3),
     +     V(3),TXX(NCOORD,3),DD(3),PT(NCOORD,3),CELL(6),DMB(MAXU),
     +     W(3),P(MAXU,3),DS(3),DSI(3,2)
      CHARACTER  NCB(MAXU)*1,ATA(MAXU)*6
      INTEGER NTR(MAXU),NLT(MAXU),IKB(NCOORD)

      READ(8,*,END=990,ERR=990)SCALE
      WRITE(9,399)SCALE
399   FORMAT(2X,'SCALE FOR PEG LENGTH IS ',F5.2/)
      IF(NLAT.EQ.1)THEN
         WRITE (9,401)
401   FORMAT(  '  CENTRAL        COORDINATING     T(X) T(Y) T(Z)  RHO
     +  PHI     DIST.   PEG'/ '   ATOM',13X,'ATOMS',48X,'LENGTH')
      ELSE
         WRITE (9,400)
400   FORMAT(  '  CENTRAL          COORDINATING   T(X) T(Y) T(Z)  RHO
     +  PHI     DIST.   PEG'/ '   ATOM',15X,'ATOMS',46X,'LENGTH')
      ENDIF
      PI = DACOS(-1.0D0)
      RAD=PI/180.0D0
C     A(I,J) IS THE DIRECT TO CARTESIAN TRANSFORMATION MATRIX
      A(1,1)=CELL(1)
      A(1,2)=CELL(2)*DCOS(CELL(6))
      A(1,3)=CELL(3)*DCOS(CELL(5))
      A(2,1)=0.0D0
      A(2,2)=CELL(2)*DSIN(CELL(6))
      A(2,3)=CELL(3)*(DCOS(CELL(4))-DCOS(CELL(5))*DCOS(CELL(6)))
     +       /DSIN(CELL(6))
      A(3,1)=0.0D0
      A(3,2)=0.0D0
      A(3,3)=DSQRT(CELL(3)**2-A(1,3)**2-A(2,3)**2)
C     CALCULATE THE D-SPACINGS FOR (100), (010), (001)... CALLED DS(1,2,3)
      VOL=A(1,1)*(A(2,2)*A(3,3)-A(2,3)*A(3,2)) - A(1,2)*(A(2,1)*A(3,3)
     &   -A(2,3)*A(3,1)) + A(1,3)*(A(2,1)*A(3,2)-A(2,2)*A(3,1))
      DS(1)=VOL/(CELL(2)*CELL(3)*DSIN(CELL(4)))
      DS(2)=VOL/(CELL(1)*CELL(3)*DSIN(CELL(5)))
      DS(3)=VOL/(CELL(1)*CELL(2)*DSIN(CELL(6)))
C     FIND A CENTRAL ATOM (KA) AND ALL THE ATOMS TO WHICH IT IS COORDINATED (KB)
      DO 550 KA=1,K
         IF(NLAT.EQ.1)THEN
            WRITE (9,405)ATA(KA),NTR(KA),KA
405         FORMAT(1X,A6,'(',I2,') ',I3)
         ELSE
            WRITE (9,404)ATA(KA),NLT(KA),NTR(KA),KA
404         FORMAT(1X,A6,'(',I1,',',I2,') ',I3)
         ENDIF
         IR=0
C     SET UP THE LIMITS FOR ADJOINING UNIT CELLS THAT COULD CONTAIN ATOMS
C        COORDINATED TO THE CENTRAL ATOM.
C        THEY ARE IN DSI(3,2), WHICH STANDS FOR D-SPACING INCREMENTS.
         DO 406 I=1,3
            DSI(I,1)=0.0D0
            DSI(I,2)=0.0D0
            X=P(KA,I)*DS(I)
            IF(X.LT.DMB(KA))DSI(I,1)=-1.0D0
            IF(DS(I)-X.LT.DMB(KA))DSI(I,2)=1.0D0
406      CONTINUE

         DO 450 KB=1,K
            KCA=2
            IF(NCB(KA).EQ.NCB(KB))GOTO 450
            DO 414 I=1,3
               DA(I)=P(KB,I)-P(KA,I)
414         CONTINUE
C     ADD TRANSLATION VECTORS AND CALCULATE INTERATOMIC DISTANCES
            DO 448 XIX=DSI(1,1),DSI(1,2),1.0D0
               DB(1)=DA(1)+XIX
               DO 447 XIY=DSI(2,1),DSI(2,2),1.0D0
                  DB(2)=DA(2)+XIY
                  DO 446 XIZ=DSI(3,1),DSI(3,2),1.0D0
                     DB(3)=DA(3)+XIZ
                     RR=0.0D0
                     DO 417 I=1,3
                        RRR=0.0D0
                        DO 416 J=1,3
                           RRR=RRR+A(I,J)*DB(J)
416                     CONTINUE
                        RR=RR+RRR**2
417                  CONTINUE
                     RR=DSQRT(RR)
                     IF(RR.GT.DMB(KA))GOTO 446
                     IR=IR+1
                     R(IR)=RR
                     IKB(IR)=KB
                     TXX(IR,1)=XIX
                     TXX(IR,2)=XIY
                     TXX(IR,3)=XIZ
446               CONTINUE
447            CONTINUE
448         CONTINUE
450      CONTINUE
         DO 548 KC=1,IR
            IK=IKB(KC)
            DO 462 I=1,3
               DD(I)=P(IK,I)-P(KA,I)+TXX(KC,I)
462         CONTINUE
            DO 465 I=1,3
               DC(I)=0.0D0
               DO 464 J=1,3
                  DC(I)=DC(I)+A(I,J)*DD(J)
464            CONTINUE
               PT(KC,I)=DC(I)
465         CONTINUE
            IF(KC.EQ.1)GOTO 482
            IF(KC.NE.KCA)GOTO 470
            DO 469 I=1,3
               DB(I)=DC(I)
469         CONTINUE
C     COMPUTE VECTOR PRODUCT
470         VI(1)=DA(2)*DC(3)-DA(3)*DC(2)
            VI(2)=DA(3)*DC(1)-DA(1)*DC(3)
            VI(3)=DA(1)*DC(2)-DA(2)*DC(1)
            VIM=0.0D0
            DO 474 I=1,3
               VIM=VIM+VI(I)**2
474         CONTINUE
            VIM=DSQRT(VIM)
            IF(KC.NE.KCA)GOTO 490
C     PICK PHI=0. VECTOR
            IF(VIM.NE.0.0D0)GOTO 478
            KCA=KCA+1
            GO TO 4924
478         DO 480 I=1,3
               V(I)=VI(I)
480         CONTINUE
            VM=VIM
            PHI=0.0D0
C     COMPUTE VECTOR PRODUCT
            W(1)=DA(2)*V(3)-DA(3)*V(2)
            W(2)=DA(3)*V(1)-DA(1)*V(3)
            W(3)=DA(1)*V(2)-DA(2)*V(1)
            GO TO 498
482         DO 484 I=1,3
               DA(I)=DC(I)
484         CONTINUE
C     RHO AND PHI ARE INDETERMINATE. SET EACH TO 999.99
            RHO=999.99D0
            PHI=999.99D0
            GO TO 520
C     COMPUTE SCALAR PRODUCTS
490         VV=0.0D0
            VW=0.0D0
            DO 492 I=1,3
               VV=VV+V(I)*VI(I)
               VW=VW+VI(I)*W(I)
492         CONTINUE
4920        TMP=VM*VIM
            IF(TMP)4921,4924,4921
C     CALCULATE PHI
4921        CPH=VV/TMP
            IF(DABS(CPH)-.99999D0)4922,4922,4923
4922        PHI=DACOS(CPH)/RAD
            GO TO 4926
4923        PHI=90.0D0-DSIGN(90.0D0,CPH)
            GO TO 4926
4924        PHI=999.99D0
            GO TO 498
4926        IF(VW)494,498,498
494         PHI=360.0D0-PHI
498         UU=0.0D0
            DO 502 I=1,3
               UU=UU+DA(I)*DC(I)
502         CONTINUE
            TMP=R(1)*R(KC)
            IF(TMP)504,512,504
504         CRH=UU/TMP
            IF(DABS(CRH)-.99999D0)506,506,508
C     CALCULATE RHO
506         RHO=DACOS(CRH)/RAD
            GO TO 520
508         RHO=90.0D0-DSIGN(90.0D0,CRH)
            GO TO 520
512         RHO=999.99D0
520         IF(PHI .EQ. 999.99D0  .OR.  PHI .EQ. 0.0D0) GO TO 521
            PHI = 360.0D0 - PHI
521         IF(NLAT.EQ.1)THEN
            WRITE (9,523)IK,ATA(IK),NTR(IK),(TXX(KC,I),I=1,3),
     +                   RHO,PHI,R(KC),R(KC)*SCALE-1.0D0
523         FORMAT(15X,I3,2X,A6,'(',I2,')',2X,3F5.0,2F8.2,F8.3,
     +             F7.1)
            ELSE
            WRITE (9,522)IK,ATA(IK),NLT(IK),NTR(IK),(TXX(KC,I),I=1,3),
     +                   RHO,PHI,R(KC),R(KC)*SCALE-1.0D0
522         FORMAT(15X,I3,2X,A6,'(',I1,',',I2,')',3F5.0,2F8.2,F8.3,F7.1)
            ENDIF
548      CONTINUE
550   CONTINUE
      RETURN
990   WRITE(*,*)' AN ERROR HAS BEEN DETECTED IN THE DATA FILE'
      WRITE(*,*)'    THE PROGRAM EXPECTED TO READ THE BOND LENGTH SCALE'
      WRITE(*,*)'    OR PERHAPS THE NUMBER OF ATOMS IS INCORRECT.'
      STOP
      END
************************************************************************
      SUBROUTINE GENERT(NSG,CELL,SGM,NX,XLAT,NLAT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION T1(3,4),T2(3,4),T3(3,4),XLAT(4,3),CELL(6),TEMP(3,4),
     +       SGM(3,4,48),TEMP1(3,4),BASIS(3,3),BASINV(3,3),SHIFT(3)
      INTEGER NPAR(5),NORD(3),NTPAR(3)

C     SUBROUTINE TO OBTAIN GENERATORS AND LATTICE VECTORS GIVEN NSG(sp. grp.#)

      DO 100 I=1,3
         NORD(I)=1
         DO 200 J=1,4
            XLAT(J,I)=0.0D0
200      CONTINUE
100   CONTINUE

      CALL SETID (T1)
      CALL SETID (T2)
      CALL SETID (T3)

      IF(NSG.EQ.0)THEN
C        NG is the number of generators to be read in.
C        The generators are input as 3x4 matricies.
         READ(8,*,END=991,ERR=991)NG
         DO 300 I=1,NG
            IF(I.EQ.1)THEN
              READ(8,*,END=992,ERR=992)((T1(K,J),J=1,4),K=1,3)
              CALL SGORD(T1,1,NORD)
            ENDIF
            IF(I.EQ.2)THEN
              READ(8,*,END=993,ERR=993)((T2(K,J),J=1,4),K=1,3)
              CALL SGORD(T2,2,NORD)
            ENDIF
            IF(I.EQ.3)THEN
              READ(8,*,END=994,ERR=994)((T3(K,J),J=1,4),K=1,3)
              CALL SGORD(T3,3,NORD)
            ENDIF
300      CONTINUE
C        Now read in the lattice type.  The origin is listed last.
         NLAT=0
         DO 400 I=1,4
            READ(8,*,END=995,ERR=995)(XLAT(I,J),J=1,3)
            NLAT=NLAT+1
            IF((XLAT(I,1).EQ.0.0D0).AND.(XLAT(I,2).EQ.0.0D0).AND.
     &         (XLAT(I,3).EQ.0.0D0))GOTO 9999
400      CONTINUE
      ENDIF

C     This part reads in info if origin and basis change
C     NFLAG indicates if this information was given.
9999  NFLAG=0
      IF(NSG.LT.0)THEN
         NFLAG=1
C        SHIFT is the name of the new origin in terms of the old basis.
         READ(8,*,END=996,ERR=996)(SHIFT(I),I=1,3)
C        BASINV(I,J) is the Ith component of the Jth vector in the new basis
C        as written in terms of the old basis.
         READ(8,*,END=997,ERR=997)((BASINV(I,J),J=1,3),I=1,3)
         CALL INV3(BASINV,BASIS,VOL2)
         NSG=-NSG
      ENDIF

      IF(NSG.GT.0)THEN
C        Check to see if monoclinic in 2nd setting
         IF( ((NSG.LE.15).AND.(NSG.GE.3)) .AND. (DABS(CELL(6)-90.0D0)
     &       .LT..000001D0) ) NSG=NSG+228
C        Check to see if Rhombohedral group in hexagonal setting.
         IF((NSG.EQ.146).AND.(DABS(CELL(6)-120.D0).LT..000001D0))NSG=244
         IF((NSG.EQ.148).AND.(DABS(CELL(6)-120.D0).LT..000001D0))NSG=245
         IF((NSG.EQ.155).AND.(DABS(CELL(6)-120.D0).LT..000001D0))NSG=246
         IF((NSG.EQ.160).AND.(DABS(CELL(6)-120.D0).LT..000001D0))NSG=247
         IF((NSG.EQ.161).AND.(DABS(CELL(6)-120.D0).LT..000001D0))NSG=248
         IF((NSG.EQ.166).AND.(DABS(CELL(6)-120.D0).LT..000001D0))NSG=249
         IF((NSG.EQ.167).AND.(DABS(CELL(6)-120.D0).LT..000001D0))NSG=250

C        NPAR(5) are the parameters corresponding to lattice type(1),
C        number of generators(2), identification of the generators(3-5).
C        Note that NPAR(2) is not used in this program.
         CALL PARAM(NSG,NPAR)
C        TPARM gets #'s corresponding to t-vectors for generators.
         CALL TPARM(NSG,NTPAR)
C        Get point group generators and their orders.
         CALL GENRTR(NPAR(3),T1,NORD(1))
         CALL GENRTR(NPAR(4),T2,NORD(2))
         CALL GENRTR(NPAR(5),T3,NORD(3))
         CALL TVEC(NTPAR(1),T1)
         CALL TVEC(NTPAR(2),T2)
         CALL TVEC(NTPAR(3),T3)
C        Obtain coset representatives of the various lattice types
         CALL LATTIC(NPAR(1),NLAT,XLAT)
      ENDIF

C     If NFLAG=1 then we used to have a negative space group number therefore
C     we need to transform the generators.
      IF(NFLAG.EQ.1)THEN
         CALL TRANSG(T1,BASIS,BASINV,SHIFT)
         CALL TRANSG(T2,BASIS,BASINV,SHIFT)
         CALL TRANSG(T3,BASIS,BASINV,SHIFT)
      ENDIF

      CALL SETID(TEMP)
      DO 40 II=1,3
         DO 40 JJ=1,4
            SGM(II,JJ,1)=TEMP(II,JJ)
40    CONTINUE
      NX=2
      DO 3000 I=1,NORD(3)
         CALL MULTMT(TEMP,T3,TEMP1)
         CALL EXCHAN(TEMP1,TEMP)
         DO 2000 J=1,NORD(2)
            CALL MULTMT(TEMP,T2,TEMP1)
            CALL EXCHAN(TEMP1,TEMP)
            DO 1000 K=1,NORD(1)
               CALL MULTMT(TEMP,T1,TEMP1)
               CALL EXCHAN(TEMP1,TEMP)
               DO 48 IX=1,3
46                IF(TEMP(IX,4).GT..999D0) THEN
                     TEMP(IX,4)=TEMP(IX,4)-1.0D0
                     GOTO 46
                  ENDIF
47                IF(TEMP(IX,4).LT.0.0D0) THEN
                     TEMP(IX,4)=TEMP(IX,4)+1.0D0
                     GOTO 47
                  ENDIF
48             CONTINUE
               IF(NX.GT.48)THEN
                  NX=48
                  RETURN
               ENDIF
               DO 50 II=1,3
                  DO 50 JJ=1,4
                     SGM(II,JJ,NX)=TEMP(II,JJ)
50             CONTINUE
               NX=NX+1
1000        CONTINUE
2000     CONTINUE
3000  CONTINUE
      NX=NX-2

      RETURN
991   WRITE(*,*)' PROBLEMS WITH THE DATA FILE: NSG=0'
      WRITE(*,*)'     EXPECTED TO READ THE NUMBER OF GENERATORS'
      STOP
992   WRITE(*,*)' PROBLEMS WITH THE DATA FILE: NSG=0'
      WRITE(*,*)'     EXPECTED TO READ THE FIRST GENERATOR'
      STOP
993   WRITE(*,*)' PROBLEMS WITH THE DATA FILE: NSG=0'
      WRITE(*,*)'     EXPECTED TO READ THE SECOND GENERATOR'
      STOP
994   WRITE(*,*)' PROBLEMS WITH THE DATA FILE: NSG=0'
      WRITE(*,*)'     EXPECTED TO READ THE THIRD GENERATOR'
      STOP
995   WRITE(*,*)' PROBLEMS WITH THE DATA FILE: NSG=0'
      WRITE(*,*)'     EXPECTED TO READ THE LATTICE CONDITIONS'
      STOP
996   WRITE(*,*)' PROBLEMS WITH THE DATA FILE: NSG<0'
      WRITE(*,*)'     EXPECTED TO READ THE SHIFT VECTOR'
      STOP
997   WRITE(*,*)' PROBLEMS WITH THE DATA FILE: NSG<0'
      WRITE(*,*)'     EXPECTED TO READ THE BASIS TRANSFORMATION'
      STOP
      END
************************************************************************
      SUBROUTINE PARAM(IDENT,PAR)
      INTEGER PAR(5),P1(5,75),P2(5,75),P3(5,100)
      DATA P1/1,1,1,1,1, 1,1,2,1,1,  1,1,3,1,1, 1,1,3,1,1, 7,1,3,1,1,
     +       1,1,9,1,1,  1,1,9,1,1,  7,1,9,1,1, 7,1,9,1,1, 1,2,2,9,1,
     +       1,2,2,9,1,  7,2,2,9,1,  1,2,2,9,1, 1,2,2,9,1, 7,2,2,9,1,
     +       1,2,3,4,1,  1,2,3,4,1,  1,2,3,4,1, 1,2,3,4,1, 4,2,3,4,1,
     +       4,2,3,4,1,  3,2,3,4,1,  2,2,3,4,1, 2,2,3,4,1, 1,2,3,10,1,
     +       1,2,3,10,1, 1,2,3,10,1, 1,2,3,10,1,1,2,3,10,1,1,2,3,10,1,
     +       1,2,3,10,1, 1,2,3,10,1, 1,2,3,10,1,1,2,3,10,1,4,2,3,10,1,
     +       4,2,3,10,1, 4,2,3,10,1, 5,2,3,10,1,5,2,3,10,1,5,2,3,10,1,
     +       5,2,3,10,1, 3,2,3,10,1, 3,2,3,10,1,2,2,3,10,1,2,2,3,10,1,
     +       2,2,3,10,1, 1,3,2,3,4,  1,3,2,3,4, 1,3,2,3,4, 1,3,2,3,4,
     +       1,3,2,3,4,  1,3,2,3,4,  1,3,2,3,4, 1,3,2,3,4, 1,3,2,3,4,
     +       1,3,2,3,4,  1,3,2,3,4,  1,3,2,3,4, 1,3,2,3,4, 1,3,2,3,4,
     +       1,3,2,3,4,  1,3,2,3,4,  4,3,2,3,4, 4,3,2,3,4, 4,3,2,3,4,
     +       4,3,2,3,4,  4,3,2,3,4,  4,3,2,3,4, 3,3,2,3,4, 3,3,2,3,4,
     +       2,3,2,3,4,  2,3,2,3,4,  2,3,2,3,4, 2,3,2,3,4, 1,1,17,1,1/
      DATA P2/1,1,17,1,1,1,1,17,1,1, 1,1,17,1,1, 2,1,17,1,1,2,1,17,1,1,
     +       1,1,18,1,1, 2,1,18,1,1, 1,2,2,17,1,1,2,2,17,1,1,2,2,17,1,
     +       1,2,2,17,1, 2,2,2,17,1, 2,2,2,17,1,1,2,4,17,1,1,2,4,17,1,
     +       1,2,4,17,1, 1,2,4,17,1, 1,2,4,17,1,1,2,4,17,1,1,2,4,17,1,
     +       1,2,4,17,1, 2,2,4,17,1, 2,2,4,17,1,1,2,10,17,1,1,2,10,17,1,
     +      1,2,10,17,1,1,2,10,17,1,1,2,10,17,1,1,2,10,17,1,1,2,10,17,1,
     +      1,2,10,17,1,2,2,10,17,1,2,2,10,17,1,2,2,10,17,1,2,2,10,17,1,
     +      1,2,4,18,1, 1,2,4,18,1, 1,2,4,18,1, 1,2,4,18,1, 1,2,10,18,1,
     +      1,2,10,18,1,1,2,10,18,1,1,2,10,18,1,2,2,10,18,1,2,2,10,18,1,
     +      2,2,4,18,1, 2,2,4,18,1, 1,3,2,4,17, 1,3,2,4,17, 1,3,2,4,17,
     +      1,3,2,4,17, 1,3,2,4,17, 1,3,2,4,17, 1,3,2,4,17, 1,3,2,4,17,
     +      1,3,2,4,17, 1,3,2,4,17, 1,3,2,4,17, 1,3,2,4,17, 1,3,2,4,17,
     +      1,3,2,4,17, 1,3,2,4,17, 1,3,2,4,17, 2,3,2,4,17, 2,3,2,4,17,
     +      2,3,2,4,17, 2,3,2,4,17, 1,1,13,1,1, 1,1,13,1,1, 1,1,13,1,1,
     +      1,1,15,1,1, 1,1,14,1,1, 1,1,16,1,1, 1,2,8,13,1, 1,2,7,13,1/
      DATA P3/1,2,8,13,1,1,2,7,13,1, 1,2,8,13,1, 1,2,7,13,1,1,2,23,15,1,
     +     1,2,12,13,1, 1,2,21,13,1,1,2,12,13,1,1,2,21,13,1,1,2,24,15,1,
     +      1,2,24,15,1,1,2,8,14,1, 1,2,8,14,1, 1,2,7,14,1, 1,2,7,14,1,
     +     1,2,24,16,1,1,2,24,16,1, 1,1,19,1,1, 1,1,19,1,1, 1,1,19,1,1,
     +      1,1,19,1,1, 1,1,19,1,1, 1,1,19,1,1, 1,1,20,1,1, 1,2,2,19,1,
     +      1,2,2,19,1, 1,2,7,19,1, 1,2,7,19,1, 1,2,7,19,1, 1,2,7,19,1,
     +      1,2,7,19,1, 1,2,7,19,1, 1,2,12,19,1,1,2,12,19,1,1,2,12,19,1,
     +      1,2,12,19,1,1,2,12,20,1,1,2,12,20,1,1,2,7,20,1, 1,2,7,20,1,
     +      1,3,2,7,19, 1,3,2,7,19, 1,3,2,7,19, 1,3,2,7,19, 1,3,3,4,15,
     +   3,3,3,4,15, 2,3,3,4,15,  1,3,3,4,15,  2,3,3,4,15,   1,3,3,4,16,
     +   1,3,3,4,16, 3,3,3,4,16,  3,3,3,4,16,  2,3,3,4,16,   1,3,3,4,16,
     +   2,3,3,4,16, 1,3,15,6,17, 1,3,15,6,17, 3,3,15,6,17, 3,3,15,6,17,
     + 2,3,15,6,17, 1,3,15,6,17, 1,3,15,6,17, 2,3,15,6,17, 1,3,15,11,18,
     +3,3,15,11,18, 2,3,15,11,18,1,3,15,11,18,3,3,15,11,18,2,3,15,11,18,
     +  1,3,16,6,17, 1,3,16,6,17, 1,3,16,6,17, 1,3,16,6,17, 3,3,16,6,17,
     +  3,3,16,6,17, 3,3,16,6,17, 3,3,16,6,17, 2,3,16,6,17, 2,3,16,6,17,
     +  1,1,5,1,1,   1,1,5,1,1,   4,1,5,1,1,   1,1,22,1,1,  1,1,22,1,1,
     +  4,1,22,1,1,  4,1,22,1,1,  1,2,2,5,1,   1,2,2,5,1,   4,2,2,5,1,
     +  1,2,2,5,1,   1,2,2,5,1,   4,2,2,5,1,   8,1,13,1,1, 8,1,14,1,1,
     +  8,2,13,7,1,  8,2,13,12,1, 8,2,13,12,1, 8,2,14,7,1, 8,2,14,7,1/

      IF (IDENT.LE.75) THEN
         DO 100 I=1,5
            PAR(I)=P1(I,IDENT)
100      CONTINUE
         RETURN
         ELSE IF (IDENT.LE.150) THEN
            DO 101 I=1,5
               PAR(I)=P2(I,IDENT-75)
101         CONTINUE
            RETURN
              ELSE
                 DO 102 I=1,5
                    PAR(I)=P3(I,IDENT-150)
102              CONTINUE
      ENDIF
      RETURN
      END
************************************************************************
      SUBROUTINE TPARM(IDENT,PAR)
      INTEGER PAR(3),T1(3,75),T2(3,75),T3(3,100)
      DATA T1/ 1, 1, 1,  1, 1, 1,  1, 1, 1,  4, 1, 1,  1, 1, 1,
     +        1, 1, 1,  3, 1, 1,  1, 1, 1,  3, 1, 1,  1, 1, 1,
     +        1, 4, 1,  1, 1, 1,  1, 3, 1,  1, 7, 1,  1, 3, 1,
     +        1, 1, 1,  4, 1, 1,  1, 5, 1,  6, 5, 1,  4, 1, 1,
     +        1, 1, 1,  1, 1, 1,  1, 1, 1,  6, 5, 1,  1, 1, 1,
     +        4, 1, 1,  1, 4, 1,  1, 2, 1,  4, 6, 1,  1, 7, 1,
     +        6, 1, 1,  1, 5, 1,  4, 8, 1,  1, 8, 1,  1, 1, 1,
     +        4, 1, 1,  1, 4, 1,  1, 1, 1,  1, 3, 1,  1, 2, 1,
     +        1, 5, 1,  1, 1, 1,  1,17, 1,  1, 1, 1,  1, 4, 1,
     +        1, 2, 1,  1, 1, 1,  8, 1, 1,  1, 1, 4,  5, 1, 1,
     +        1, 2, 2,  1, 2, 7,  1, 6, 1,  1, 2, 6,  1, 1, 5,
     +        1, 5, 6,  1, 4, 3,  1, 1, 8,  5, 1, 5,  1, 8, 5,
     +        1, 6, 5,  1, 6, 8,  1, 4, 1,  1, 7, 1,  1, 1, 1,
     +        1, 1, 4,  1, 2, 1,  7, 1, 1,  1, 1, 1, 17, 1, 1,
     +        1, 1, 1,  1, 1, 4,  1, 3, 4,  1, 3, 1,  1, 1, 1/
      DATA T2/13, 1, 1,  4, 1, 1, 14, 1, 1,  1, 1, 1, 15, 1, 1,
     +        1, 1, 1,  1, 1, 1,  1, 1, 1,  1, 4, 1,  5, 5, 1,
     +        8, 8, 1,  1, 1, 1, 15,15, 1,  1, 1, 1,  5, 5, 1,
     +        4,13, 1, 19,18, 1,  1, 4, 1,  8, 8, 1,  4,14, 1,
     +       18,19, 1,  1, 1, 1, 15,15, 1,  1, 1, 1,  5, 1, 1,
     +        4, 4, 1,  8, 8, 1,  4, 1, 1,  8, 1, 1,  1, 4, 1,
     +        5, 4, 1,  1, 1, 1,  5, 1, 1,  1,15, 1,  4,15, 1,
     +        1, 1, 1,  4, 1, 1,  5, 1, 1,  8, 1, 1,  1, 1, 1,
     +        4, 1, 1,  5, 1, 1,  8, 1, 1,  1, 1, 1,  4, 1, 1,
     +        1, 1, 1, 15, 1, 1,  1, 1, 1,  1, 4, 1,  5, 1, 1,
     +        8, 1, 1,  1, 5, 1,  1, 8, 1,  5, 5, 5,  5, 8, 5,
     +        1, 1, 4,  1, 4, 4,  8, 4, 8,  8, 1, 8,  1, 5, 4,
     +        1, 8, 8,  8, 8, 8,  8, 5, 8,  1, 1, 1,  1, 4, 1,
     +       15,15,15, 15,16,15,  1, 1, 1, 10, 1, 1, 11, 1, 1,
     +        1, 1, 1,  1, 1, 1,  1, 1, 1,  1, 1, 1,  1, 1, 1/
      DATA T3/ 1,10, 1, 11,10, 1,  1,11, 1, 10,11, 1,  1, 1, 1,
     +        1, 1, 1,  1, 1, 1,  4, 1, 1,  4, 1, 1,  1, 1, 1,
     +        8, 1, 1,  1, 1, 1,  4, 1, 1,  1, 1, 1,  4, 1, 1,
     +        1, 1, 1,  8, 1, 1,  1, 1, 1,  9, 1, 1, 12, 1, 1,
     +       10, 1, 1, 11, 1, 1,  4, 1, 1,  1, 1, 1,  1, 1, 1,
     +        1, 4, 1,  1, 1, 1,  1, 9, 1,  1,12, 1,  1,10, 1,
     +        1,11, 1,  1, 4, 1,  1, 1, 1,  4, 1, 1,  4, 4, 1,
     +        1, 4, 1,  1, 1, 1,  4, 4, 1,  1, 1, 1,  1, 4, 1,
     +        1, 1, 1,  1, 4, 1,  1, 4, 4,  1, 1, 4,  1, 1, 1,
     +        1, 1, 1,  1, 1, 1,  6, 5, 1,  6, 5, 1,  1, 1, 1,
     +        1, 1, 8,  1, 1, 1,  1, 1,17,  1, 1, 1,  6, 5, 1,
     +        3, 4, 1,  1, 1, 1,  1, 8, 8,  1, 1, 1,  1,17,17,
     +        1, 1, 1,  1,20,23,  1,21,22,  1,20,23,  1, 1, 1,
     +        1, 1, 1,  1, 1, 1,  1, 8, 8,  1, 4, 4,  1,20,23,
     +        1, 1, 1,  8, 1, 1,  1, 8, 8,  8, 8, 8,  1, 1, 1,
     +        1, 4, 4, 17,17,17, 24,17,17,  1, 1, 1,  1,20,23,
     +        1, 1, 1,  3, 1, 1,  1, 1, 1,  1, 1, 1,  4, 1, 1,
     +        1, 1, 1,  4, 1, 1,  1, 1, 1,  1, 3, 1,  1, 1, 1,
     +        1, 4, 1,  1, 7, 1,  1, 4, 1,  1, 1, 1,  1, 1, 1,
     +        1, 1, 1,  1, 1, 1,  1, 4, 1,  1, 1, 1,  1, 4, 1/

      IF (IDENT.LE.75) THEN
         DO 101 I=1,3
            PAR(I)=T1(I,IDENT)
101      CONTINUE
         RETURN
         ELSE IF (IDENT.LE.150) THEN
            DO 102 I=1,3
               PAR(I)=T2(I,IDENT-75)
102         CONTINUE
            RETURN
              ELSE
                 DO 103 I=1,3
                    PAR(I)=T3(I,IDENT-150)
103              CONTINUE
      ENDIF
      RETURN
      END
************************************************************************
      SUBROUTINE GENRTR (IDENT,MAT,ORDER)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION MAT
      DIMENSION MAT(3,4)
      INTEGER GEN(3,72),ORDER,O(24)
      DATA GEN/1, 0, 0, 0, 1, 0, 0, 0, 1, -1, 0, 0, 0,-1, 0, 0, 0,-1,
     +        -1, 0, 0, 0,-1, 0, 0, 0, 1,  1, 0, 0, 0,-1, 0, 0, 0,-1,
     +        -1, 0, 0, 0, 1, 0, 0, 0,-1,  0, 1, 0, 1, 0, 0, 0, 0,-1,
     +         1, 0, 0,-1,-1, 0, 0, 0,-1,  1, 1, 0, 0,-1, 0, 0, 0,-1,
     +         1, 0, 0, 0, 1, 0, 0, 0,-1, -1, 0, 0, 0, 1, 0, 0, 0, 1,
     +         0,-1, 0,-1, 0, 0, 0, 0, 1, -1, 0, 0, 1, 1, 0, 0, 0, 1,
     +         0, 1, 0,-1,-1, 0, 0, 0, 1,  0,-1, 0, 1, 1, 0, 0, 0,-1,
     +         0, 1, 0, 0, 0, 1, 1, 0, 0,  0,-1, 0, 0, 0,-1,-1, 0, 0,
     +         0, 1, 0,-1, 0, 0, 0, 0, 1,  0,-1, 0, 1, 0, 0, 0, 0,-1,
     +         1, 1, 0,-1, 0, 0, 0, 0, 1, -1,-1, 0, 1, 0, 0, 0, 0,-1,
     +        -1,-1, 0, 0, 1, 0, 0, 0, 1,  1, 0, 0, 0,-1, 0, 0, 0, 1,
     +         0, 0,-1, 0,-1, 0,-1, 0, 0,  0, 0, 1, 0, 1, 0, 1, 0, 0/
      DATA O/1,2,2,2,2,2,2,2,2,2,2,2,3,6,3,6,4,4,6,6,2,2,2,2/

      DO 100 I=1,3
         DO 100 J=1,3
            MAT(I,J)=DBLE(GEN(I,(IDENT-1)*3+J))
100   CONTINUE

      ORDER=O(IDENT)

      RETURN
      END
************************************************************************
      SUBROUTINE TVEC(N,P)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION P(3,4)
      INTEGER VEC(3,27)
      DATA VEC/0,0,0, 6,0,0, 0,6,0, 0,0,6,  6,6,0, 6,0,6, 0,6,6, 6,6,6,
     +         0,0,2, 0,0,4, 0,0,8, 0,0,10, 0,0,3, 0,0,9, 0,6,3, 0,6,9,
     +         3,3,3, 6,6,3, 6,6,9, 3,9,9,  9,3,3, 3,9,3, 9,3,9, 3,3,9,
     +         9,9,3, 4,8,8, 8,4,4/

      DO 100 I=1,3
         P(I,4)=DBLE(VEC(I,N))/12.0D0
100   CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE LATTIC(N,NLAT,XLAT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XLAT(4,3)
      INTEGER LAT1(5,8),IVEC(3,7)
      DATA LAT1/1,1,1,1,1, 2,1,5,1,1, 4,1,2,3,4,  2,1,2,1,1,
     +          2,1,4,1,1, 1,1,1,1,1, 2,1,3,1,1,  3,1,6,7,1/
      DATA IVEC/0,0,0,  6,6,0,  6,0,6, 0,6,6, 6,6,6, 4,8,8, 8,4,4/

      NLAT=LAT1(1,N)
      DO 100 I=1,4
         IDENT=LAT1(I+1,N)
         DO 100 J=1,3
            XLAT(I,J)=DBLE(IVEC(J,IDENT))/12.0D0
100   CONTINUE
      RETURN
      END
************************************************************************
      SUBROUTINE SETID (T)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION T(3,4)
      DO 10 I = 1,3
           DO 20 J = 1,4
                T(I,J) = 0.0D0
  20       CONTINUE
           T(I,I) = 1.0D0
  10  CONTINUE
      RETURN
      END
***********************************************************************
C     MULTIPLIES 3X4 MATRICES
      SUBROUTINE MULTMT(X,Y,Z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(3,4),Y(3,4),Z(3,4)

      DO 100 I=1,3
         DO 100 J=1,3
            Z(I,J)=0.0D0
            DO 100 K=1,3
               Z(I,J)=Z(I,J)+X(I,K)*Y(K,J)
100   CONTINUE
      Z(1,4)=X(1,1)*Y(1,4)+X(1,2)*Y(2,4)+X(1,3)*Y(3,4)+X(1,4)
      Z(2,4)=X(2,1)*Y(1,4)+X(2,2)*Y(2,4)+X(2,3)*Y(3,4)+X(2,4)
      Z(3,4)=X(3,1)*Y(1,4)+X(3,2)*Y(2,4)+X(3,3)*Y(3,4)+X(3,4)
      RETURN
      END
*******************************************************************************
*                                  INV3                                       *
*           Calculates, given a 3x3 matrix (B), the inverse of the            *
*                     matrix (BI) and the volume (VOL2).                      *
*******************************************************************************
      SUBROUTINE INV3(B,BI,VOL2)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION B(3,3),BI(3,3)

      VOL2=B(1,1)*(B(2,2)*B(3,3)-B(2,3)*B(3,2)) - B(1,2)*(B(2,1)*B(3,3)
     &   -B(2,3)*B(3,1)) + B(1,3)*(B(2,1)*B(3,2)-B(2,2)*B(3,1))
      IF(DABS(VOL2).LT.1.0D-20) THEN
         WRITE(9,*)'The change of basis vectors are linearly dep',
     &      'endent'
         STOP
      ENDIF
      BI(1,1)=(B(2,2)*B(3,3)-B(2,3)*B(3,2))/VOL2
      BI(1,2)=(B(1,3)*B(3,2)-B(1,2)*B(3,3))/VOL2
      BI(1,3)=(B(1,2)*B(2,3)-B(2,2)*B(1,3))/VOL2
      BI(2,1)=(B(2,3)*B(3,1)-B(2,1)*B(3,3))/VOL2
      BI(2,2)=(B(1,1)*B(3,3)-B(1,3)*B(3,1))/VOL2
      BI(2,3)=(B(1,3)*B(2,1)-B(1,1)*B(2,3))/VOL2
      BI(3,1)=(B(2,1)*B(3,2)-B(2,2)*B(3,1))/VOL2
      BI(3,2)=(B(1,2)*B(3,1)-B(1,1)*B(3,2))/VOL2
      BI(3,3)=(B(1,1)*B(2,2)-B(1,2)*B(2,1))/VOL2
      RETURN
      END
*******************************************************************************
*                                   SGORD                                  *
*               Determines the order of a space group generator               *
*******************************************************************************
      SUBROUTINE SGORD(T,LFLAG,NORD)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER NORD(3)
      DIMENSION T(3,4),TEST(4,4),TT(4,4),DIF(4,4),DIFF(4,4),TTEST(4,4)

C     T(3,4) is the space group generator (T1,T2,or T3) depending on LFLAG.
C     T is cast into TEST(4,4) for matrix order (NORD(3)) determination.
      DO 200 I=1,3
      TEST(4,I)=0.0D0
         DO 300 J=1,4
            TEST(I,J)=T(I,J)
300      CONTINUE
200   CONTINUE
      TEST(4,4)=1.0D0

      CALL MATID4(TT)
      CALL MATID4(DIF)
C     This do loop multiplies the TEST matrix by itself until the identity is
C     discovered.  The value(K) of the do loop equals the order of the matrix.
      DO 1000 K=1,6
         M=0
         CALL M4BYM4(TEST,TT,TTEST)
         DO 400 I=1,4
            DO 500 J=1,4
               TT(I,J)=TTEST(I,J)
               DIFF(I,J)=DIF(I,J)-TT(I,J)
C              Test to see if element in the fourth column is equal to 1.
C              If the element is equal to 1, set equal to 0.
               IF(I.NE.4)THEN
                  IF(DABS(DIFF(I,4)).GE.0.98D0)DIFF(I,4)=0.0D0
               ENDIF
               IF(DABS(DIFF(I,J)).LE.1.0D-10)M=M+1
500         CONTINUE
400      CONTINUE
         IF(M.EQ.16)GO TO 999
1000  CONTINUE
      WRITE(9,*)'SPACE GROUP GENERATOR WAS ENTERED IMPROPERLY'
      RETURN
999   NORD(LFLAG)=K
      RETURN
      END
*******************************************************************************
*                                 MATID4                                      *
*             Sets a 4X4 matrix equal to the identity matrix                  *
*******************************************************************************
      SUBROUTINE MATID4(T)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION T(4,4)

      DO 100 I = 1,4
         DO 200 J = 1,4
            T(I,J) = 0.0D0
200      CONTINUE
         T(I,I) = 1.0D0
100   CONTINUE
      RETURN
      END
*******************************************************************************
*                                   M4BYM4                                    *
*                    Multiplies a (4X4) matrix by a (4X4)                     *
*******************************************************************************
      SUBROUTINE M4BYM4 (TN,T,TEMP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION TN(4,4),T(4,4),TEMP(4,4)

      DO 100 I = 1,4
         DO 200 J = 1,4
            TEMP(I,J)=TN(I,1)*T(1,J)+TN(I,2)*T(2,J)+TN(I,3)*T(3,J)
     &         +TN(I,4)*T(4,J)
200      CONTINUE
100   CONTINUE
      RETURN
      END
*******************************************************************************
      SUBROUTINE EXCHAN(X,Y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(3,4),Y(3,4)

      DO 50 II=1,3
         DO 50 JJ=1,4
            Y(II,JJ)=X(II,JJ)
50    CONTINUE
      RETURN
      END
*******************************************************************************
*                                 TRANSG                                    *
*          Transforms space group generators to new origin and basis          *
*******************************************************************************
      SUBROUTINE TRANSG(T,BASIS,BASINV,SHIFT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION T(3,4),TT(3),BASIS(3,3),BASINV(3,3),TMAT(3,3),SHIFT(3)

C     Transform translation vector part (t) of generator according to
C     T(M-I3)p+t where here p = shift (or new origin) and T = BASIS
C     and M is the 3x4 generator
      DO 100 I = 1,3
         DO 200 J = 1,3
            TMAT(I,J)=T(I,J)
200      CONTINUE
         TMAT(I,I)=TMAT(I,I)-1.0D0
100   CONTINUE
      DO 120 I=1,3
         TT(I)=TMAT(I,1)*SHIFT(1)+TMAT(I,2)*SHIFT(2)+TMAT(I,3)*SHIFT(3)
     &         +T(I,4)
120   CONTINUE
      DO 140 I=1,3
         T(I,4)=BASIS(I,1)*TT(1) + BASIS(I,2)*TT(2) + BASIS(I,3)*TT(3)
140   CONTINUE
C                                                        -1
C     Transform linear part of generator according to TMT
      DO 1000 I = 1,3
         DO 2000 J = 1,3
            TMAT(I,J)=T(I,1)*BASINV(1,J) + T(I,2)*BASINV(2,J)
     &               +T(I,3)*BASINV(3,J)
2000     CONTINUE
1000  CONTINUE

      DO 1001 I = 1,3
         DO 2001 J = 1,3
            T(I,J)=BASIS(I,1)*TMAT(1,J) + BASIS(I,2)*TMAT(2,J) +
     &             BASIS(I,3)*TMAT(3,J)
2001     CONTINUE
1001  CONTINUE

      RETURN
      END
*******************************************************************************
